Index: modules/uoa-services-library/trunk/ng-openaire-library/src/app/landingPages/landing-utils/parsingFunctions.class.ts
===================================================================
--- modules/uoa-services-library/trunk/ng-openaire-library/src/app/landingPages/landing-utils/parsingFunctions.class.ts	(revision 58274)
+++ modules/uoa-services-library/trunk/ng-openaire-library/src/app/landingPages/landing-utils/parsingFunctions.class.ts	(revision 58275)
@@ -1,45 +1,32 @@
+import {HostedByCollectedFrom, Journal, Project, RelationResult} from "../../utils/result-preview/result-preview";
 
 export class ParsingFunctions {
-
-  constructor () {}
-
-  public ngOnDestroy() {}
-
-  public parseFundingByProjects(fundedByProjects: { "id": string, "acronym": string, "title": string,
-                                                    "funderShortname": string, "funderName": string,
-                                                    "funding": string, "code": string,
-                                                    "provenanceAction": string, "inline": boolean
-                                                  }[],
-                                relation: any, provenanceActionVocabulary: any):
-                            { "id": string, "acronym": string, "title": string,
-                              "funderShortname": string, "funderName": string,
-                              "funding": string, "code": string,
-                              "provenanceAction": string, "inline": boolean
-                            }[] {
-    if(fundedByProjects == undefined) {
-      fundedByProjects = new Array<{"id": string, "acronym": string, "title": string,
-                                    "funderShortname": string, "funderName": string,
-                                    "funding": string, "code": string,
-                                    "provenanceAction": string, "inline": boolean
-                                  }>();
+  
+  constructor() {
+  }
+  
+  public ngOnDestroy() {
+  }
+  
+  public parseFundingByProjects(fundedByProjects: Project[], relation: any,
+                                provenanceActionVocabulary: any): Project[] {
+    if (fundedByProjects == undefined) {
+      fundedByProjects = [];
     }
-
-    let fundedByProject:  { "id": string, "acronym": string, "title": string,
-                            "funderShortname": string, "funderName": string,
-                            "funding": string, "code": string,
-                            "provenanceAction": string, "inline": boolean
-                          } = { "id": "", "acronym": "", "title": "",
-                                "funderShortname": "", "funderName": "",
-                                "funding": "", "code": "", "provenanceAction": "", "inline": false
-                          };
-
-    if(relation.title != 'unidentified') {
+    
+    let fundedByProject: Project = {
+      "id": "", "acronym": "", "title": "",
+      "funderShortname": "", "funderName": "",
+      "funding": "", "code": "", "provenanceAction": "", "inline": false
+    };
+    
+    if (relation.title != 'unidentified') {
       fundedByProject['id'] = relation['to'].content;
       fundedByProject['acronym'] = relation.acronym;
       fundedByProject['title'] = relation.title;
       fundedByProject['code'] = relation.code;
-
-      if(provenanceActionVocabulary != null && relation.provenanceaction in provenanceActionVocabulary) {
+      
+      if (provenanceActionVocabulary != null && relation.provenanceaction in provenanceActionVocabulary) {
         fundedByProject['provenanceAction'] = provenanceActionVocabulary[relation.provenanceaction];
       }
     } else {
@@ -49,18 +36,18 @@
       fundedByProject['code'] = "";
       fundedByProject['provenanceAction'] = "";
     }
-
-    if(relation.hasOwnProperty("funding")) {
-      let funding: {"funderName": string, "funderShortname": string, "stream": string};
+    
+    if (relation.hasOwnProperty("funding")) {
+      let funding: { "funderName": string, "funderShortname": string, "stream": string };
       funding = this.parseFundingTrees(relation.funding);
-
-      if(funding.funderName) {
+      
+      if (funding.funderName) {
         fundedByProject['funderName'] = funding.funderName;
       }
-      if(funding.funderShortname) {
+      if (funding.funderShortname) {
         fundedByProject['funderShortname'] = funding.funderShortname;
       }
-      if(funding.stream) {
+      if (funding.stream) {
         fundedByProject['funding'] = funding.stream;
       }
     }
@@ -67,71 +54,75 @@
     fundedByProjects.push(fundedByProject);
     return fundedByProjects;
   }
-
+  
   // publication & research data : for fundedByProjects | project landing : for funding
-  public parseFundingTrees(fundingTree: any): {"funderName": string, "funderShortname": string, "stream": string} {
-    let funding: {"funderName": string, "funderShortname": string, "stream": string} = {"funderName": "", "funderShortname": "", "stream": ""};
+  public parseFundingTrees(fundingTree: any): { "funderName": string, "funderShortname": string, "stream": string } {
+    let funding: { "funderName": string, "funderShortname": string, "stream": string } = {
+      "funderName": "",
+      "funderShortname": "",
+      "stream": ""
+    };
     let length = Array.isArray(fundingTree) ? fundingTree.length : 1;
-
-    for(let i=0; i<length; i++) {
+    
+    for (let i = 0; i < length; i++) {
       let fundingData = Array.isArray(fundingTree) ? fundingTree[i] : fundingTree;
-
-      if(fundingData.hasOwnProperty("funder")) {
+      
+      if (fundingData.hasOwnProperty("funder")) {
         funding.funderShortname = fundingData['funder'].shortname;
         funding.funderName = fundingData['funder'].name;
       }
-
+      
       funding.stream = this.addFundingLevel0(fundingData, funding.stream);
-
+      
       funding.stream = this.addFundingLevel1(fundingData, funding.stream);
-
+      
       funding.stream = this.addFundingLevel2(fundingData, funding.stream);
     }
     return funding;
   }
-
-  addFundingLevel0(parent: string, fundingStream: string) : string {
-    if(parent.hasOwnProperty("funding_level_0")) {
+  
+  addFundingLevel0(parent: string, fundingStream: string): string {
+    if (parent.hasOwnProperty("funding_level_0")) {
       let level0 = parent['funding_level_0'];
-
+      
       fundingStream += (fundingStream) ? " ; " : "";
       fundingStream += level0.name;
     }
     return fundingStream;
   }
-
+  
   addFundingLevel1(parent: string, fundingStream: string): string {
-    if(parent.hasOwnProperty("funding_level_1")) {
+    if (parent.hasOwnProperty("funding_level_1")) {
       let level1 = parent['funding_level_1'];
-
+      
       // For projects' parsing
-      if(level1.hasOwnProperty("parent")) {
+      if (level1.hasOwnProperty("parent")) {
         fundingStream = this.addFundingLevel0(level1.parent, fundingStream);
       }
-
+      
       fundingStream += (fundingStream) ? " | " : "";
       fundingStream += level1.name;
     }
     return fundingStream;
   }
-
+  
   addFundingLevel2(parent: string, fundingStream: string): string {
-    if(parent.hasOwnProperty("funding_level_2")) {
+    if (parent.hasOwnProperty("funding_level_2")) {
       let level2 = parent['funding_level_2'];
-
+      
       // For projects' parsing
-      if(level2.hasOwnProperty("parent")) {
+      if (level2.hasOwnProperty("parent")) {
         fundingStream = this.addFundingLevel1(level2.parent, fundingStream);
       }
-
+      
       fundingStream += (fundingStream) ? " | " : "";
       fundingStream += level2.name;
     }
     return fundingStream;
   }
-
+  
   // publication & dataset landing : for collectedFrom
-  parseCollectedFrom( collectedFrom: {"name": string, "id": string}[],
+  parseCollectedFrom(collectedFrom: { "name": string, "id": string }[],
                      _collectedFrom: any) {
     let length: number = collectedFrom.length;
     collectedFrom[length] = {"name": "", "id": ""};
@@ -138,56 +129,63 @@
     collectedFrom[length]['name'] = _collectedFrom.name;
     collectedFrom[length]['id'] = _collectedFrom.id;
   }
-
+  
   // publication & dataset landing : for downloadFrom
-  addPublisherToHostedBy_collectedFrom( hostedBy_collectedFrom: {"downloadName": string, "downloadUrl": string[], "collectedName": string, "collectedId": string, "accessMode": string[], "bestAccessMode": string, "type": string, "year":string}[],
-                              publisher: string, journal:{"journal": string, "issn": string, "lissn": string},
-                              identifiers: Map<string, string[]>/*, title: { "name": string, "url": string, "accessMode": string}*/) {
-    if( publisher && identifiers != null && identifiers.has('doi')) {
-      if( hostedBy_collectedFrom == null) {
-        hostedBy_collectedFrom = new Array<{"downloadName": string, "downloadUrl": string[], "collectedName": string, "collectedId": string, "accessMode": string[], "bestAccessMode": string, "type": string, "year":string}>();
+  addPublisherToHostedBy_collectedFrom(hostedBy_collectedFrom: HostedByCollectedFrom[],
+                                       publisher: string, journal: Journal,
+                                       identifiers: Map<string, string[]>/*, title: { "name": string, "url": string, "accessMode": string}*/) {
+    if (publisher && identifiers != null && identifiers.has('doi')) {
+      if (hostedBy_collectedFrom == null) {
+        hostedBy_collectedFrom = [];
       }
-      let available: {"downloadName": string, "downloadUrl": string[], "collectedName": string, "collectedId": string, "accessMode": string[], "bestAccessMode": string, "type": string, "year":string};
-      available = {"downloadName": "", "downloadUrl": null, "collectedName": "", "collectedId": "", "accessMode": null, "bestAccessMode": null, "type": "", "year": ""};
-
-      if(journal && journal.journal) {
-        available.downloadName = publisher + "/ "+journal['journal'];
+      let available: HostedByCollectedFrom = {
+        downloadName: "",
+        downloadUrl: null,
+        collectedName: "",
+        collectedId: "",
+        accessMode: null,
+        bestAccessMode: null,
+        type: "",
+        year: ""
+      };
+      
+      if (journal && journal.journal) {
+        available.downloadName = publisher + "/ " + journal['journal'];
       } else {
         available.downloadName = publisher;
       }
-
-      let url = "https://dx.doi.org/"+identifiers.get("doi")[0];
-
+      
+      let url = "https://dx.doi.org/" + identifiers.get("doi")[0];
+      
       available.downloadUrl = new Array<string>();
       available.accessMode = new Array<string>();
-
+      
       available.downloadUrl.push(url);
-/*
-      if(title != undefined && title['url'] == "") {
-        title['url'] = url;
-      }
-*/
+      /*
+            if(title != undefined && title['url'] == "") {
+              title['url'] = url;
+            }
+      */
       hostedBy_collectedFrom.push(available);
     }
     return hostedBy_collectedFrom;
   }
-
+  
   // publication & dataset landing : for downloadFrom
-  parseDownloadFrom(downloadFrom: Map<string, {"url": string[], "accessMode": string[], "bestAccessMode": string}>, instance: any, url: string)
-  {
+  parseDownloadFrom(downloadFrom: Map<string, { "url": string[], "accessMode": string[], "bestAccessMode": string }>, instance: any, url: string) {
     let key: string = instance['hostedby'].name;
-
-    if(key) {
+    
+    if (key) {
       this.addUrlAndAccessMode(downloadFrom, instance, key, url);
     }
   }
-
+  
   // publication & dataset landing : for publishedIn
-  parsePublishedIn(publishedIn: Map<string, {"url": string[], "accessMode": string[], "bestAccessMode": string}>, instance: any, result: any, url: string, counter: number): number {
-    if(result != null && result.hasOwnProperty("source")) {
+  parsePublishedIn(publishedIn: Map<string, { "url": string[], "accessMode": string[], "bestAccessMode": string }>, instance: any, result: any, url: string, counter: number): number {
+    if (result != null && result.hasOwnProperty("source")) {
       let key: string;
-      if(Array.isArray(result.source)) {
-        if(counter==result.source.length) {
+      if (Array.isArray(result.source)) {
+        if (counter == result.source.length) {
           counter--;
         }
         key = result['source'][counter];
@@ -194,8 +192,8 @@
       } else {
         key = result['source'];
       }
-
-      if(key) {
+      
+      if (key) {
         this.addUrlAndAccessMode(publishedIn, instance, key, url);
         counter++;
       }
@@ -202,160 +200,165 @@
     }
     return counter;
   }
-
+  
   // publication & dataset landing : for downloadFrom and publishedIn
-  addUrlAndAccessMode(mapStructure: Map<string, {"url": string[], "accessMode": string[], "bestAccessMode": string}>, instance: any, key: string, url: string) {
-    if(!mapStructure.has(key)) {
+  addUrlAndAccessMode(mapStructure: Map<string, { "url": string[], "accessMode": string[], "bestAccessMode": string }>, instance: any, key: string, url: string) {
+    if (!mapStructure.has(key)) {
       mapStructure.set(key, {"url": null, "accessMode": null, "bestAccessMode": null});
     }
-
-    if(mapStructure.get(key)['url'] == null) {
+    
+    if (mapStructure.get(key)['url'] == null) {
       mapStructure.get(key)['url'] = new Array<string>();
     }
-
-    if(url) {
+    
+    if (url) {
       mapStructure.get(key)['url'].push(url);
     }
-
-    if(mapStructure.get(key)['accessMode'] == null) {
+    
+    if (mapStructure.get(key)['accessMode'] == null) {
       mapStructure.get(key)['accessMode'] = new Array<string>();
     }
-
-    if(instance.hasOwnProperty("accessright")) {
-      if(url) {
-        mapStructure.get(key)['accessMode'].push(instance['accessright'].classid);
+    
+    if (instance.hasOwnProperty("accessright")) {
+      if (url) {
+        mapStructure.get(key)['accessMode'].push(instance['accessright'].classname);
       }
-
-      if(this.changeBestAccessMode(mapStructure.get(key)['bestAccessMode'], instance['accessright'])) {
-        mapStructure.get(key)['bestAccessMode'] = instance['accessright'].classid;
+      
+      if (this.changeBestAccessMode(mapStructure.get(key)['bestAccessMode'], instance['accessright'])) {
+        mapStructure.get(key)['bestAccessMode'] = instance['accessright'].classname;
       }
-    } else if(url) {
+    } else if (url) {
       mapStructure.get(key)['accessMode'].push("");
     }
   }
-
-
-  parseHostedBy_collectedFrom(hostedBy_collectedFrom: { "downloadName": string, "downloadUrl": string[],
-                                  "collectedName": string, "collectedId": string,
-                                  "accessMode": string[], "bestAccessMode": string,
-                                  "type": string, "year":string }[],
+  
+  
+  parseHostedBy_collectedFrom(hostedBy_collectedFrom: HostedByCollectedFrom[],
                               instance: any, data: any, url: string, counter: number/*,
                               title: { "name": string, "url": string, "accessMode": string}*/, accessMode: string): number {
-     let available: {"downloadName": string, "downloadUrl": string[], "collectedName": string, "collectedId": string, "accessMode": string[], "bestAccessMode": string, "type": string, "year":string};
-     available = {"downloadName": "", "downloadUrl": null, "collectedName": "", "collectedId": "", "accessMode": null, "bestAccessMode": null, "type": "", "year": ""};
-
-     if(instance['hostedby'].name && instance['hostedby'].name != "other resources" && instance['hostedby'].name != "Unknown Repository") {
-       available.downloadName = instance['hostedby'].name;
-     } else {
-       if(data != null && data.hasOwnProperty("source")) {
-         let downloadName: string;
-         if(Array.isArray(data.source)) {
-
-           if(counter==data.source.length) {
-             counter--;
-           }
-           downloadName = data['source'][counter];
-         } else {
-           downloadName = data['source'];
-         }
-         if(downloadName) {
-           counter++;
-           available.downloadName = downloadName;
-         }
-       }
-
-     }
-
-     if(available.downloadName) {
-       if(instance.hasOwnProperty("collectedfrom")) {
-         available.collectedId = instance['collectedfrom'].id;
-         available.collectedName = instance['collectedfrom'].name;
-       }
-
-       if(instance.hasOwnProperty("instancetype") && instance['instancetype'].classname) {
-         available.type = instance['instancetype'].classname;
-       }
-
-       if(instance.hasOwnProperty("dateofacceptance")) {
-         var date:string = (instance.dateofacceptance)+""; // transform to string in case it is an integer
-         available.year  = (date && (date).indexOf('-') !== -1)?date.split('-')[0]:date;
-       }
-
-       available.accessMode = new Array<string>();
-       available.downloadUrl = new Array<string>();
-       available['downloadUrl'].push(url);
-       if(instance.hasOwnProperty("accessright")) {
-         if(url) {
-           available['accessMode'].push(instance['accessright'].classid);
-         }
-
-         if(this.changeBestAccessMode(available.bestAccessMode, instance['accessright'])) {
-           available.bestAccessMode = instance['accessright'].classid;
-/*
-           if(title != undefined) {
-             if(this.changeBestAccessMode(title['accessMode'], instance['accessright'])) {
-               title['accessMode'] = instance['accessright'].classid;
-               title['url'] = url;
-             }
-           }
-*/
-          if(this.changeBestAccessMode(accessMode, instance['accessright'])) {
-            accessMode = instance['accessright'].classid;
+    let available: HostedByCollectedFrom = {
+      "downloadName": "",
+      "downloadUrl": null,
+      "collectedName": "",
+      "collectedId": "",
+      "accessMode": null,
+      "bestAccessMode": null,
+      "type": "",
+      "year": ""
+    };
+    
+    if (instance['hostedby'].name && instance['hostedby'].name != "other resources" && instance['hostedby'].name != "Unknown Repository") {
+      available.downloadName = instance['hostedby'].name;
+    } else {
+      if (data != null && data.hasOwnProperty("source")) {
+        let downloadName: string;
+        if (Array.isArray(data.source)) {
+          
+          if (counter == data.source.length) {
+            counter--;
           }
-         }
-/*
-         if(title != undefined) {
-           if(!title['url']) {
-             title['url'] = url;
-           }
-         }
-*/
-       } else if(url) {
-         available['accessMode'].push("");
-       }
-
-       hostedBy_collectedFrom.push(available);
-     }
-
-     return counter;
+          downloadName = data['source'][counter];
+        } else {
+          downloadName = data['source'];
+        }
+        if (downloadName) {
+          counter++;
+          available.downloadName = downloadName;
+        }
+      }
+      
+    }
+    
+    if (available.downloadName) {
+      if (instance.hasOwnProperty("collectedfrom")) {
+        available.collectedId = instance['collectedfrom'].id;
+        available.collectedName = instance['collectedfrom'].name;
+      }
+      
+      if (instance.hasOwnProperty("instancetype") && instance['instancetype'].classname) {
+        available.type = instance['instancetype'].classname;
+      }
+      
+      if (instance.hasOwnProperty("dateofacceptance")) {
+        var date: string = (instance.dateofacceptance) + ""; // transform to string in case it is an integer
+        available.year = (date && (date).indexOf('-') !== -1) ? date.split('-')[0] : date;
+      }
+      
+      available.accessMode = new Array<string>();
+      available.downloadUrl = new Array<string>();
+      available['downloadUrl'].push(url);
+      if (instance.hasOwnProperty("accessright")) {
+        if (url) {
+          available['accessMode'].push(instance['accessright'].classname);
+        }
+        
+        if (this.changeBestAccessMode(available.bestAccessMode, instance['accessright'])) {
+          available.bestAccessMode = instance['accessright'].classname;
+          /*
+                     if(title != undefined) {
+                       if(this.changeBestAccessMode(title['accessMode'], instance['accessright'])) {
+                         title['accessMode'] = instance['accessright'].classid;
+                         title['url'] = url;
+                       }
+                     }
+          */
+          if (this.changeBestAccessMode(accessMode, instance['accessright'])) {
+            accessMode = instance['accessright'].classname;
+          }
+        }
+        /*
+                 if(title != undefined) {
+                   if(!title['url']) {
+                     title['url'] = url;
+                   }
+                 }
+        */
+      } else if (url) {
+        available['accessMode'].push("");
+      }
+      
+      hostedBy_collectedFrom.push(available);
+    }
+    
+    return counter;
   }
-
+  
   // publication & dataset landing : for downloadFrom and publishedIn
   changeBestAccessMode(currentAccessMode: string, accessMode: any): boolean {
-    if(!accessMode) {
+    if (!accessMode) {
       return false;
     }
     accessMode = accessMode.classid;
-
+    
     switch (currentAccessMode) {
       case null:
-        if(accessMode != "UNKNOWN") {
+        if (accessMode != "UNKNOWN") {
           return true;
         }
         return false;
       case "CLOSED":
-        if( accessMode == "OPEN" ||
-            accessMode == "OPEN SOURCE" ||
-            accessMode == "EMBARGO" ||
-            accessMode == "RESTRICTED") {
-              return true;
+        if (accessMode == "OPEN" ||
+          accessMode == "OPEN SOURCE" ||
+          accessMode == "EMBARGO" ||
+          accessMode == "RESTRICTED") {
+          return true;
         }
         return false;
       case "RESTRICTED":
-        if( accessMode == "OPEN" ||
-            accessMode == "OPEN SOURCE" ||
-            accessMode == "EMBARGO") {
-              return true;
+        if (accessMode == "OPEN" ||
+          accessMode == "OPEN SOURCE" ||
+          accessMode == "EMBARGO") {
+          return true;
         }
         return false;
       case "EMBARGO":
-        if( accessMode == "OPEN" ||
-            accessMode == "OPEN SOURCE") {
+        if (accessMode == "OPEN" ||
+          accessMode == "OPEN SOURCE") {
           return true;
         }
         return false;
       case "OPEN SOURCE":
-        if( accessMode == "OPEN") {
+        if (accessMode == "OPEN") {
           return true;
         }
         return false;
@@ -362,112 +365,100 @@
     }
     return false;
   }
-
+  
   // publication & dataset & software & orp landing : for relatedResearchResults
-  parseRelatedResearchResults(relatedResearchResults: Map<string, { "name": string, "id": string, "date": string,
-                    "percentage": number, "class": string}[]>, relation: any, provenanceAction: string) :
-                        Map<string, { "name": string, "id": string, "date": string,
-                                      "percentage": number, "class": string}[]> {
-    if(relatedResearchResults == undefined) {
-      relatedResearchResults = new Map<string, {"name": string, "id": string, "date": string,
-                                                "percentage": number, "class": string }[]>();
+  parseRelatedResearchResults(relatedResearchResults: RelationResult[], relation: any, provenanceAction: string):
+    RelationResult[] {
+    if (relatedResearchResults == undefined) {
+      relatedResearchResults = []
     }
-
-    if(!relatedResearchResults.has(provenanceAction)) {
-      relatedResearchResults.set(provenanceAction,
-                        new Array<{ "name": string, "id": string, "date": string,
-                                    "percentage": number, "class": string }>());
-    }
-    relatedResearchResults.get(provenanceAction).push(this.parseRelatedOrSimilarResearchResult(relation, "trust"));
-
+    relatedResearchResults.push(this.parseRelatedOrSimilarResearchResult(relation, "trust", provenanceAction));
     return relatedResearchResults;
   }
-
+  
   // publication & dataset & software & orp landing : for supplementaryResearchResults
-  parseSupplementaryResearchResults(supplementaryResearchResults: { "name": string, "id": string, "date": string,
-                                                        "percentage": number, "class": string}[], relation: any) :
-                { "name": string, "id": string, "date": string, "percentage": number, "class": string }[] {
-    if(supplementaryResearchResults == undefined) {
-      supplementaryResearchResults = new Array<{"name": string, "id": string, "date": string,
-                                          "percentage": number, "class": string}>();
+  parseSupplementaryResearchResults(supplementaryResearchResults: RelationResult[], relation: any): RelationResult[] {
+    if (supplementaryResearchResults == undefined) {
+      supplementaryResearchResults = [];
     }
     supplementaryResearchResults.push(this.parseRelatedOrSimilarResearchResult(relation, "trust"));
     return supplementaryResearchResults;
   }
-
+  
   // publication & dataset & software & orp landing : for supplementedByResearchResults
-  parseSupplementedByResearchResults(supplementedByResearchResults: { "name": string, "id": string, "date": string,
-    "percentage": number, "class": string}[], relation: any) :
-    { "name": string, "id": string, "date": string, "percentage": number, "class": string }[] {
-    if(supplementedByResearchResults == undefined) {
-      supplementedByResearchResults = new Array<{"name": string, "id": string, "date": string,
-        "percentage": number, "class": string}>();
+  parseSupplementedByResearchResults(supplementedByResearchResults: RelationResult[], relation: any): RelationResult[] {
+    if (supplementedByResearchResults == undefined) {
+      supplementedByResearchResults = [];
     }
     supplementedByResearchResults.push(this.parseRelatedOrSimilarResearchResult(relation, "trust"));
     return supplementedByResearchResults;
   }
-
+  
   // publication & dataset & software & orp landing : for similarResearchResults
-  parseSimilarResearchResults(similarResearchResults: { "name": string, "id": string, "date": string,
-    "percentage": number, "class": string}[], relation: any) :
-    { "name": string, "id": string, "date": string, "percentage": number, "class": string }[] {
-    if(similarResearchResults == undefined) {
-      similarResearchResults = new Array<{"name": string, "id": string, "date": string,
-        "percentage": number, "class": string}>();
+  parseSimilarResearchResults(similarResearchResults: RelationResult[], relation: any): RelationResult[] {
+    if (similarResearchResults == undefined) {
+      similarResearchResults = [];
     }
     similarResearchResults.push(this.parseRelatedOrSimilarResearchResult(relation, "similarity"));
     return similarResearchResults;
   }
-
+  
   // publication & dataset & software & orp landing : for relatedResearchResults and similarResearchResults
-  parseRelatedOrSimilarResearchResult(relation: any, percentageName: string): {"name": string, "id": string, "date": string, "percentage": number, "class": string} {
-    let researchResult: {"name": string, "id": string, "date": string, "percentage": number, "class": string}
-                              = {"name": "", "id": "", "date": "", "percentage": null, "class": ""}
-    if(relation['resulttype'].classname == "publication") {
+  parseRelatedOrSimilarResearchResult(relation: any, percentageName: string, provenanceAction: string = null): RelationResult {
+    let researchResult: RelationResult = {
+      name: "",
+      id: "",
+      date: "",
+      percentage: null,
+      class: "",
+      provenanceAction: provenanceAction
+    };
+    if (relation['resulttype'].classname == "publication") {
       researchResult['class'] = "publication";
-    } else if(relation['resulttype'].classname == "dataset") {
+    } else if (relation['resulttype'].classname == "dataset") {
       researchResult['class'] = "dataset";
-    } else if(relation['resulttype'].classname == "software") {
+    } else if (relation['resulttype'].classname == "software") {
       researchResult['class'] = "software";
-    } else if(relation['resulttype'].classname == "other") {
+    } else if (relation['resulttype'].classname == "other") {
       researchResult['class'] = "other";
     }
-
     researchResult['id'] = relation['to'].content;
     let titleName = Array.isArray(relation['title']) ? relation['title'][0].content : relation['title'].content;
     researchResult['name'] = titleName;
-    if(relation.hasOwnProperty("dateofacceptance")) {
-      var date:string = ((Array.isArray(relation.dateofacceptance))?(relation.dateofacceptance[0]):(relation.dateofacceptance))+""; // transform to string in case it is an integer
-      researchResult['date']  = (date && (date).indexOf('-') !== -1)?date.split('-')[0]:date;
+    if (relation.hasOwnProperty("dateofacceptance")) {
+      var date: string = ((Array.isArray(relation.dateofacceptance)) ? (relation.dateofacceptance[0]) : (relation.dateofacceptance)) + ""; // transform to string in case it is an integer
+      researchResult['date'] = (date && (date).indexOf('-') !== -1) ? date.split('-')[0] : date;
     }
     //researchResult['date'] = relation.dateofacceptance.substring(0,4);;
-    researchResult['percentage'] = Math.round(relation[percentageName]*100);
+    researchResult['percentage'] = Math.round(relation[percentageName] * 100);
     return researchResult;
   }
-
-  sortByPercentage(results: { "name": string, "id": string, "date": string, "percentage": number, "class": string}[]) : { "name": string, "id": string, "date": string, "percentage": number, "class": string}[] {
-    if(results) {
-       return results.sort(function(a, b){return b["percentage"] - a["percentage"]});
+  
+  sortByPercentage(results: RelationResult[]): RelationResult[] {
+    if (results) {
+      return results.sort(function (a, b) {
+        return b["percentage"] - a["percentage"]
+      });
     }
     return results;
   }
-
+  
   // publication & dataset landing : for identifiers
   parseIdentifiers(pid: any): Map<string, string[]> {
     let identifiers = new Map<string, string[]>();
-
-    if(pid.hasOwnProperty("classname") && pid['classname'] != "") {
-      if(pid.classname == "doi" || pid.classname == "pmc" || pid.classname == "handle") {
-        if(!identifiers.has(pid.classname)) {
+    
+    if (pid.hasOwnProperty("classname") && pid['classname'] != "") {
+      if (pid.classname == "doi" || pid.classname == "pmc" || pid.classname == "handle" || pid == "pmid") {
+        if (!identifiers.has(pid.classname)) {
           identifiers.set(pid.classname, new Array<string>());
         }
-
+        
         identifiers.get(pid.classname).push(pid.content);
       }
     } else {
-      for(let i=0; i<pid.length; i++) {
-        if(pid[i].classname == "doi" || pid[i].classname == "pmc" || pid[i].classname == "handle") {
-          if(!identifiers.has(pid[i].classname)) {
+      for (let i = 0; i < pid.length; i++) {
+        if (pid[i].classname == "doi" || pid[i].classname == "pmc" || pid[i].classname == "handle" || pid == "pmid") {
+          if (!identifiers.has(pid[i].classname)) {
             identifiers.set(pid[i].classname, new Array<string>());
           }
           identifiers.get(pid[i].classname).push(pid[i].content);
